# Модуль автоматической установки размеров рамки карты в отчете в соответствии
# с масштабом (1:500)
from PySide2.QtWidgets import QMessageBox
from axipy import *

class Plugin(AxiomaPlugin):
    def load(self):
        isReport=state_manager.get(state_manager.MapView)
        no_Rep=state_manager.create('NoRep', not isReport.value())
        isReport.changed.connect(lambda: no_Rep.setValue(isReport.value()))

        self.__action = self.create_action('Размер рамки',
                icon=self.local_file('ui', 'dialog.png'), on_click=self.Ramka,enable_on='NoRep')
        position = Position('Отчет', 'Элементы')
        position.add(self.__action)
        self.__action.action.setToolTip('Автоматическая установка размера рамки')

    def unload(self):
        self.__action.remove()

    def Ramka(self):
        #-------------------------------------------------
        sc=500 # масштаб карты в отчете
        #-------------------------------------------------
        rv=view_manager.reportviews[0] #находим первое окно отчета
        rv.unit='cm'
        mv=view_manager.active #находим активное окно
        try:
            map=mv.map
            mc=mv.center # центр окна карты
            rect=mv.scene_rect
            H=rect.height/(sc/100) # требуемая высота окна отчета в см
            L=rect.width/(sc/100) # требуемая ширина окна отчета в см
            if H<2000 or L<2000: # не превышают ли размеры отчета 20 м?
                mapItem = MapReportItem(Rect(0,0,L,H), map)
                mapItem.scale = sc #устанавливаем масштаб карты в элементе отчета
                mapItem.center=mc  # центр картыв окне отчета
                rv.report.items.add(mapItem)
                rv.report.fit_pages() # подбираем число страниц
                view_manager.activate(rv) #окно отчета на передний план
            else:
                QMessageBox.information(None, 'Внимание!','Размер отчета превышает 20 метров!')
        except:
            QMessageBox.information(None, 'Внимание!','Сделайте активным окно карты!')